Name:           mirrormanager
Version:        1.3.7
Release:        1%{?dist}
Summary:        Fedora mirror management system
BuildArch:      noarch

Group:          Applications/Internet
License:        MIT and GPLv2
URL:            http://fedorahosted.org/mirrormanager
Source0:        https://fedorahosted.org/releases/m/i/%{name}/%{name}-%{version}.tar.bz2
BuildRoot:      %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
BuildRequires:  python
Requires:       TurboGears, python-IPy, python-GeoIP, wget, yum, psmisc, python-dns, python-fedora >= 0.3.14, py-radix, mod_wsgi
Requires:       python-basemap >= 0.99.4, python-basemap-data >= 0.99.4
Requires(pre):  shadow-utils

%define py_ver         %(echo `python -c "import sys; print sys.version[:3]"`)
%if "%{py_ver}" < "2.5"
# for md5, sha1, sha256, which are native to python 2.5 and higher
Requires: python-hashlib
%endif

%description
MirrorManager tracks all the content provided on a master mirror
server, and that of all public and private mirrors of that content.
This package contains the application server, database schema and
hosted tools.

%package client
Requires:       python
Summary:        Fedora mirror management system downstream mirror tools
Group:          Applications/Internet

%description client
Client-side, run on each downstream mirror, to report back to the
MirrorManager database a description of the content carried by that
mirror.

%prep
%setup -q

%build

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT CONFFILE="%{_sysconfdir}/%{name}/prod.cfg" PROGRAMDIR="%{_datadir}/%{name}/server" SBINDIR="%{_sbindir}"


%clean
rm -rf $RPM_BUILD_ROOT


%pre
getent group mirrormanager >/dev/null || groupadd -r mirrormanager
getent passwd mirrormanager >/dev/null || \
  useradd -r -g mirrormanager -d /var/lib/mirrormanager -s /sbin/nologin \
  -c "MirrorManager" mirrormanager
exit 0

%files
%defattr(-,root,root,-)
%{_datadir}/%{name}
%attr(-,mirrormanager,mirrormanager) %dir %{_localstatedir}/lib/%{name}/
%attr(-,mirrormanager,mirrormanager) %dir %{_localstatedir}/run/%{name}/
%attr(-,mirrormanager,mirrormanager) %dir %{_localstatedir}/log/%{name}/
%attr(-,mirrormanager,mirrormanager) %dir %{_localstatedir}/log/%{name}/crawler/
%attr(-,mirrormanager,mirrormanager) %dir %{_localstatedir}/lock/%{name}/
%attr(-,mirrormanager,mirrormanager) %dir %{_sysconfdir}/%{name}/
%attr(-,mirrormanager,mirrormanager) %config(noreplace) /etc/mirrormanager/prod.cfg
%attr(-,mirrormanager,mirrormanager) %config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%attr(-,mirrormanager,mirrormanager) %config(noreplace) %{_sysconfdir}/httpd/conf.d/mirrormanager.conf
%attr(-,mirrormanager,mirrormanager) %config(noreplace) %{_sysconfdir}/httpd/conf.d/mirrorlist-server.conf
%dir /etc/rpmlint/
%config(noreplace) /etc/rpmlint/%{name}.config
%doc LICENSES LICENSE-MIT-X11 LICENSE-GPLv2
%doc server/*.cfg server/prod.cfg.example README.rpm_setup
%doc server/UPGRADING.txt server/sqlobject-patches/

%files client
%defattr(-,root,root,-)
%{_bindir}/report_mirror
%dir %{_sysconfdir}/%{name}-client
%config(noreplace) %{_sysconfdir}/%{name}-client/report_mirror.conf
%doc LICENSE-MIT-X11 client/README


%changelog
* Sat Sep 11 2010 Matt Domsch <mdomsch@fedoraproject.org> - 1.3.7-1
Matt Domsch:
      mirrorlist_server: always output a metalink header
      crawler: fix indentation, causing crawler to fail

* Sat Jul 31 2010 Matt Domsch <mdomsch@fedoraproject.org> - 1.3.6-1
Matt Domsch (8):
      mirrorlist_server: add mm0:private attribute to <url> in metalinks
      add repomaps for RHEL
      category named "RHEL", not "Red Hat Enterprise Linux".  Fix references.
      repomap: remove extra -beta on prefixes
      umdl: set Repository.name = directory.name to be guaranteed unique
      remove robots.txt and favicon.ico.  These should come from the hosting organization, not MM.
      crawler: don't close sys.stdout as logfile, leave that for sys.exit()

* Wed May 26 2010 Matt Domsch <mdomsch@fedoraproject.org> - 1.3.5-1
- Adrian Reber (1):
      mirrorlist_server: handle bad client IP address input
- Matt Domsch (18):
      spec: require python-basemap-data too
      makefile: add git-sign-push target to remind me
      crawler: implement canary mode
      crawler: crawl private i2 hosts that also say i2_clients are ok
      crawler: send email when marking a whole host not up2date
      mirrorlist_server: ignore SIGHUP in child - it'll exit soon enough
      mirrorlist_server: increase socket request queue length to 300 (still limited by kernel options to 128)
      mirrorlist_server: set request_queue_size earlier
      mirrorlist_server: don't ignore SIGCHLD
      mirrorlist tester: more printing, run forever
      mirrorlist_client: sanitize input into UTF-8
      mirrorlist_client: add 60sec timeout to reading from the server
      mirrorlist_client: use select() waiting on the response from mirrorlist_server
      mirrorlist_client: a better way to handle socket timeouts
      mirrorlist_client: leave query params as utf8
      mirrorlist_server: handle more failures gracefully
      mirrorlist_client: add mirrorlist_client.noreverseproxy config parameter
      umdl: don't use move_repository_from_development()

* Mon Apr 26 2010 Matt Domsch <mdomsch@fedoraproject.org> - 1.3.4-1
- Adrian Reber (2):
      umdl: fix failure when updating from rsync listings.
      umdl: time.mktime() might return floats
- BJ Dierkes (1):
      Fix confirm delete method in webui.
- Matt Domsch (34):
      mrr: add --updates-only option
      controllers: add mirroradmins query
      umdl: fix crash in _get_version_from_path()
      umdl: avoid disappering files
      report_mirror: handle server HTTP 503 errors
      generate-worldmap: update for newer python-basemap
      autodetect development/13/ style directories and create appropriate Repositories
      umdl: recognize moving Repository objects from development/13 to releases/13/
      mrr: genericize --from and --to version values
      get_internet2_netblocks: fix URL due to upstream directory change
      Put titles on publiclist pages
      expose crawler logs via apache directory listing
      add crawler log link on host page
      apache: ensure aliases to special areas come before the WSGI alias
      remove python-fedora deprecation warning
      add config option report_problems_to_email, display on publiclist footer.
      ageFileDetails(): account for propogation delays
      add max_propogation_days config option
      spec: require python-basemap > 0.99.4 so generate-worldmap works
      mirrorlist-server: use WSGIDaemonProcess for mirrorlist_client.wsgi
      mirrormanager.wsgi run 4 instances per app server (up from 2)

* Mon Oct 26 2009 Matt Domsch <mdomsch@fedoraproject.org> - 1.3.3-2
- add patch to fix confirm delete from webui

* Thu Sep 28 2009 Matt Domsch <mdomsch@fedoraproject.org> - 1.3.3-1
- initial setup patches from BJ Dierkes
  - simpler mirrormanager.initial, README.rpm_setup, prod.cfg
  - add user mirrormanager and group mirrormanager, content permissions

* Thu Sep 28 2009 Matt Domsch <mdomsch@fedoraproject.org> - 1.3.2-1
- add BGP ASN lookups

* Fri Sep 18 2009 Matt Domsch <mdomsch@fedoraproject.org> - 1.3.1-1
- fix publiclist html
- fix Host netblock creation via web UI

* Mon Sep  7 2009 Matt Domsch <mdomsch@fedoraproject.org> - 1.3.0-1
- add CSRF protection, add Requires: python-fedora
- add IPv6 capability
- switch DNS lookups to use python-dns
- other misc bugfixes

* Thu Jul  9 2009 Matt Domsch <mdomsch@fedoraproject.org> - 1.2.12-1
- bug fixes post F11 release

* Mon Apr 20 2009 Mike McGrath <mmcgrath@fedoraproject.org> 1.2.11-2
- Added psmisc Requires

* Tue Apr  7 2009 Matt Domsch <mdomsch@fedoraproject.org> - 1.2.11-1
- fix quite a few bugs from previous version

* Mon Apr  6 2009 Matt Domsch <mdomsch@fedoraproject.org> - 1.2.10-1
- improved crawler repomd.xml verification
- improved publiclist generation
- fix categorymap logic
- WSGI-ify web application
- vastly speed up report_mirror (no more stat()s on every file)
- vastly speed up umdl
- add rsyncFilter

* Mon Feb 23 2009 Matt Domsch <mdomsch@fedoraproject.org> - 1.2.9-1
- Adrian Reber:
      mirrorlist-server: check values returned by geoip before printing
      mirrorlist-server: ignore SIGCHLD to not have zombie processes
      server: also use project name and URL from config file for publiclist
      server: removed debug messages to decrease MM's verbosity
      server: make it work with Fedora's 10 python version
- Jeroen van Meeuwen:
      Strip duplicate // from the path requested
- Matt Domsch:
      revert publiclist_host() changes from 6a056929007b9b6bdf35367818e1212895c5bdec
         which weren't any faster and yet generated incorrect results.
      add item to TODO
      add push-mirroring doc
      mirrorlist: add trailing / to returned URLs to directories.
      Better handle Host creation form validation failure error case.

* Tue Dec  2 2008 Matt Domsch <mdomsch@fedoraproject.org> - 1.2.8-1
- don't place metalink-downloaded files deep in a directory tree

* Mon Dec  1 2008 Matt Domsch <mdomsch@fedoraproject.org> - 1.2.7-1
- Adrian Reber
  add mirrorlist_statistics.py
- Matt Domsch
  fix metalinks, cleanup publiclist a bit, add s390x
  cleanup license files

* Mon Dec 01 2008 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> - 1.2.6-2
- Rebuild for Python 2.6

* Mon Oct 13 2008 Matt Domsch <mdomsch@fedoraproject.org> - 1.2.6-1
- even more bugfixes

* Sat Oct  4 2008 Matt Domsch <mdomsch@fedoraproject.org> - 1.2.5-1
- more bugfixes

* Fri Oct  3 2008 Matt Domsch <mdomsch@fedoraproject.org> - 1.2.4-1
- more bugfixes

* Sun Sep 28 2008 Matt Domsch <mdomsch@fedoraproject.org> - 1.2.3-1
- lots of bugfixes

* Fri Sep 26 2008 Matt Domsch <mdomsch@fedoraproject.org> - 1.2.2-1
- initial package attempt
